package org.eclipse.sirius.sample.bmod.design;

import java.util.*;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.sirius.sample.bmod.*;

/**
 * The services class used by VSM.
 */
public class Services {
    
    public Boolean allRoomsConnected(Room r) {
    	List<Cell> cells = r.getCell();
    	Boolean allConnected = false;
    	for(Cell c : cells) {
    		Door d = c.getDoor();
    		if(d!=null)
    			allConnected = true;
    	}
    	return allConnected;
    }
    
    public Boolean doorIsInSameRoom(Room r) {
    	List<Cell> cells = r.getCell();
    	for(Cell c : cells) {
    		Door d = c.getDoor();
    		if(d != null) {
    			List<Target> targets = d.getTarget();
    			for(Target t : targets) {
    				if(t.getClass() == c.getClass() && t!=c) {
    					if(cells.contains(t)) {
    						return false;
    					}
    				}
    			}
    		}
    	}
    	return true;
    }
    
    public Boolean signTargetIsNotConnectedToOutside(EmergencySign e) {
    	List<Door> targets = e.getTarget();
    	for(Door d : targets) {
    		List<Target> dtargets = d.getTarget();
    		if(dtargets.get(0).getClass() != dtargets.get(1).getClass())
    			return true;
    	}
    	return false;
    }
    
}




