/**
 */
package org.eclipse.sirius.sample.bmod;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each operation of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see org.eclipse.sirius.sample.bmod.BmodFactory
 * @model kind="package"
 * @generated
 */
public interface BmodPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "bmod";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://www.eclipse.org/sirius/sample/bmod";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "bmod";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	BmodPackage eINSTANCE = org.eclipse.sirius.sample.bmod.impl.BmodPackageImpl.init();

	/**
	 * The meta object id for the '{@link org.eclipse.sirius.sample.bmod.impl.FloorImpl <em>Floor</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.sirius.sample.bmod.impl.FloorImpl
	 * @see org.eclipse.sirius.sample.bmod.impl.BmodPackageImpl#getFloor()
	 * @generated
	 */
	int FLOOR = 0;

	/**
	 * The feature id for the '<em><b>Door</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOOR__DOOR = 0;

	/**
	 * The feature id for the '<em><b>Outside</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOOR__OUTSIDE = 1;

	/**
	 * The feature id for the '<em><b>Room</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOOR__ROOM = 2;

	/**
	 * The number of structural features of the '<em>Floor</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOOR_FEATURE_COUNT = 3;

	/**
	 * The number of operations of the '<em>Floor</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOOR_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link org.eclipse.sirius.sample.bmod.impl.RoomImpl <em>Room</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.sirius.sample.bmod.impl.RoomImpl
	 * @see org.eclipse.sirius.sample.bmod.impl.BmodPackageImpl#getRoom()
	 * @generated
	 */
	int ROOM = 9;

	/**
	 * The meta object id for the '{@link org.eclipse.sirius.sample.bmod.impl.TargetImpl <em>Target</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.sirius.sample.bmod.impl.TargetImpl
	 * @see org.eclipse.sirius.sample.bmod.impl.BmodPackageImpl#getTarget()
	 * @generated
	 */
	int TARGET = 8;

	/**
	 * The feature id for the '<em><b>Door</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TARGET__DOOR = 0;

	/**
	 * The number of structural features of the '<em>Target</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TARGET_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Target</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TARGET_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link org.eclipse.sirius.sample.bmod.impl.CellImpl <em>Cell</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.sirius.sample.bmod.impl.CellImpl
	 * @see org.eclipse.sirius.sample.bmod.impl.BmodPackageImpl#getCell()
	 * @generated
	 */
	int CELL = 1;

	/**
	 * The feature id for the '<em><b>Door</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CELL__DOOR = TARGET__DOOR;

	/**
	 * The feature id for the '<em><b>Right</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CELL__RIGHT = TARGET_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Left</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CELL__LEFT = TARGET_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Top</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CELL__TOP = TARGET_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Bottom</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CELL__BOTTOM = TARGET_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Content</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CELL__CONTENT = TARGET_FEATURE_COUNT + 4;

	/**
	 * The number of structural features of the '<em>Cell</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CELL_FEATURE_COUNT = TARGET_FEATURE_COUNT + 5;

	/**
	 * The number of operations of the '<em>Cell</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CELL_OPERATION_COUNT = TARGET_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.sirius.sample.bmod.impl.ContentImpl <em>Content</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.sirius.sample.bmod.impl.ContentImpl
	 * @see org.eclipse.sirius.sample.bmod.impl.BmodPackageImpl#getContent()
	 * @generated
	 */
	int CONTENT = 2;

	/**
	 * The number of structural features of the '<em>Content</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTENT_FEATURE_COUNT = 0;

	/**
	 * The number of operations of the '<em>Content</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTENT_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link org.eclipse.sirius.sample.bmod.impl.OccupantImpl <em>Occupant</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.sirius.sample.bmod.impl.OccupantImpl
	 * @see org.eclipse.sirius.sample.bmod.impl.BmodPackageImpl#getOccupant()
	 * @generated
	 */
	int OCCUPANT = 3;

	/**
	 * The feature id for the '<em><b>Is Alarmed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OCCUPANT__IS_ALARMED = CONTENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Perception</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OCCUPANT__PERCEPTION = CONTENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Action</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OCCUPANT__ACTION = CONTENT_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Occupant</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OCCUPANT_FEATURE_COUNT = CONTENT_FEATURE_COUNT + 3;

	/**
	 * The number of operations of the '<em>Occupant</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OCCUPANT_OPERATION_COUNT = CONTENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.sirius.sample.bmod.impl.DoorImpl <em>Door</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.sirius.sample.bmod.impl.DoorImpl
	 * @see org.eclipse.sirius.sample.bmod.impl.BmodPackageImpl#getDoor()
	 * @generated
	 */
	int DOOR = 4;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOOR__TARGET = 0;

	/**
	 * The number of structural features of the '<em>Door</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOOR_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Door</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOOR_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link org.eclipse.sirius.sample.bmod.impl.FireImpl <em>Fire</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.sirius.sample.bmod.impl.FireImpl
	 * @see org.eclipse.sirius.sample.bmod.impl.BmodPackageImpl#getFire()
	 * @generated
	 */
	int FIRE = 5;

	/**
	 * The number of structural features of the '<em>Fire</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FIRE_FEATURE_COUNT = CONTENT_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Fire</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FIRE_OPERATION_COUNT = CONTENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.sirius.sample.bmod.impl.EmergencySignImpl <em>Emergency Sign</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.sirius.sample.bmod.impl.EmergencySignImpl
	 * @see org.eclipse.sirius.sample.bmod.impl.BmodPackageImpl#getEmergencySign()
	 * @generated
	 */
	int EMERGENCY_SIGN = 6;

	/**
	 * The feature id for the '<em><b>Sorce</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EMERGENCY_SIGN__SORCE = 0;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EMERGENCY_SIGN__TARGET = 1;

	/**
	 * The number of structural features of the '<em>Emergency Sign</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EMERGENCY_SIGN_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Emergency Sign</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EMERGENCY_SIGN_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link org.eclipse.sirius.sample.bmod.impl.OutsideImpl <em>Outside</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.sirius.sample.bmod.impl.OutsideImpl
	 * @see org.eclipse.sirius.sample.bmod.impl.BmodPackageImpl#getOutside()
	 * @generated
	 */
	int OUTSIDE = 7;

	/**
	 * The feature id for the '<em><b>Door</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OUTSIDE__DOOR = TARGET__DOOR;

	/**
	 * The number of structural features of the '<em>Outside</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OUTSIDE_FEATURE_COUNT = TARGET_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Outside</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OUTSIDE_OPERATION_COUNT = TARGET_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROOM__NAME = 0;

	/**
	 * The feature id for the '<em><b>Condition</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROOM__CONDITION = 1;

	/**
	 * The feature id for the '<em><b>Cell</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROOM__CELL = 2;

	/**
	 * The feature id for the '<em><b>Emergencysign</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROOM__EMERGENCYSIGN = 3;

	/**
	 * The number of structural features of the '<em>Room</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROOM_FEATURE_COUNT = 4;

	/**
	 * The number of operations of the '<em>Room</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROOM_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link org.eclipse.sirius.sample.bmod.perceptions <em>perceptions</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.sirius.sample.bmod.perceptions
	 * @see org.eclipse.sirius.sample.bmod.impl.BmodPackageImpl#getperceptions()
	 * @generated
	 */
	int PERCEPTIONS = 10;

	/**
	 * The meta object id for the '{@link org.eclipse.sirius.sample.bmod.actions <em>actions</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.sirius.sample.bmod.actions
	 * @see org.eclipse.sirius.sample.bmod.impl.BmodPackageImpl#getactions()
	 * @generated
	 */
	int ACTIONS = 11;

	/**
	 * Returns the meta object for class '{@link org.eclipse.sirius.sample.bmod.Floor <em>Floor</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Floor</em>'.
	 * @see org.eclipse.sirius.sample.bmod.Floor
	 * @generated
	 */
	EClass getFloor();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.sirius.sample.bmod.Floor#getRoom <em>Room</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Room</em>'.
	 * @see org.eclipse.sirius.sample.bmod.Floor#getRoom()
	 * @see #getFloor()
	 * @generated
	 */
	EReference getFloor_Room();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.sirius.sample.bmod.Floor#getDoor <em>Door</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Door</em>'.
	 * @see org.eclipse.sirius.sample.bmod.Floor#getDoor()
	 * @see #getFloor()
	 * @generated
	 */
	EReference getFloor_Door();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.sirius.sample.bmod.Floor#getOutside <em>Outside</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Outside</em>'.
	 * @see org.eclipse.sirius.sample.bmod.Floor#getOutside()
	 * @see #getFloor()
	 * @generated
	 */
	EReference getFloor_Outside();

	/**
	 * Returns the meta object for class '{@link org.eclipse.sirius.sample.bmod.Room <em>Room</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Room</em>'.
	 * @see org.eclipse.sirius.sample.bmod.Room
	 * @generated
	 */
	EClass getRoom();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.sirius.sample.bmod.Room#getCell <em>Cell</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Cell</em>'.
	 * @see org.eclipse.sirius.sample.bmod.Room#getCell()
	 * @see #getRoom()
	 * @generated
	 */
	EReference getRoom_Cell();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.sirius.sample.bmod.Room#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see org.eclipse.sirius.sample.bmod.Room#getName()
	 * @see #getRoom()
	 * @generated
	 */
	EAttribute getRoom_Name();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.sirius.sample.bmod.Room#getCondition <em>Condition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Condition</em>'.
	 * @see org.eclipse.sirius.sample.bmod.Room#getCondition()
	 * @see #getRoom()
	 * @generated
	 */
	EAttribute getRoom_Condition();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.sirius.sample.bmod.Room#getEmergencysign <em>Emergencysign</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Emergencysign</em>'.
	 * @see org.eclipse.sirius.sample.bmod.Room#getEmergencysign()
	 * @see #getRoom()
	 * @generated
	 */
	EReference getRoom_Emergencysign();

	/**
	 * Returns the meta object for class '{@link org.eclipse.sirius.sample.bmod.Cell <em>Cell</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Cell</em>'.
	 * @see org.eclipse.sirius.sample.bmod.Cell
	 * @generated
	 */
	EClass getCell();

	/**
	 * Returns the meta object for the reference '{@link org.eclipse.sirius.sample.bmod.Cell#getRight <em>Right</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Right</em>'.
	 * @see org.eclipse.sirius.sample.bmod.Cell#getRight()
	 * @see #getCell()
	 * @generated
	 */
	EReference getCell_Right();

	/**
	 * Returns the meta object for the reference '{@link org.eclipse.sirius.sample.bmod.Cell#getLeft <em>Left</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Left</em>'.
	 * @see org.eclipse.sirius.sample.bmod.Cell#getLeft()
	 * @see #getCell()
	 * @generated
	 */
	EReference getCell_Left();

	/**
	 * Returns the meta object for the reference '{@link org.eclipse.sirius.sample.bmod.Cell#getTop <em>Top</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Top</em>'.
	 * @see org.eclipse.sirius.sample.bmod.Cell#getTop()
	 * @see #getCell()
	 * @generated
	 */
	EReference getCell_Top();

	/**
	 * Returns the meta object for the reference '{@link org.eclipse.sirius.sample.bmod.Cell#getBottom <em>Bottom</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Bottom</em>'.
	 * @see org.eclipse.sirius.sample.bmod.Cell#getBottom()
	 * @see #getCell()
	 * @generated
	 */
	EReference getCell_Bottom();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.sirius.sample.bmod.Cell#getContent <em>Content</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Content</em>'.
	 * @see org.eclipse.sirius.sample.bmod.Cell#getContent()
	 * @see #getCell()
	 * @generated
	 */
	EReference getCell_Content();

	/**
	 * Returns the meta object for class '{@link org.eclipse.sirius.sample.bmod.Content <em>Content</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Content</em>'.
	 * @see org.eclipse.sirius.sample.bmod.Content
	 * @generated
	 */
	EClass getContent();

	/**
	 * Returns the meta object for class '{@link org.eclipse.sirius.sample.bmod.Occupant <em>Occupant</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Occupant</em>'.
	 * @see org.eclipse.sirius.sample.bmod.Occupant
	 * @generated
	 */
	EClass getOccupant();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.sirius.sample.bmod.Occupant#isIsAlarmed <em>Is Alarmed</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Is Alarmed</em>'.
	 * @see org.eclipse.sirius.sample.bmod.Occupant#isIsAlarmed()
	 * @see #getOccupant()
	 * @generated
	 */
	EAttribute getOccupant_IsAlarmed();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.sirius.sample.bmod.Occupant#getPerception <em>Perception</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Perception</em>'.
	 * @see org.eclipse.sirius.sample.bmod.Occupant#getPerception()
	 * @see #getOccupant()
	 * @generated
	 */
	EAttribute getOccupant_Perception();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.sirius.sample.bmod.Occupant#getAction <em>Action</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Action</em>'.
	 * @see org.eclipse.sirius.sample.bmod.Occupant#getAction()
	 * @see #getOccupant()
	 * @generated
	 */
	EAttribute getOccupant_Action();

	/**
	 * Returns the meta object for class '{@link org.eclipse.sirius.sample.bmod.Door <em>Door</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Door</em>'.
	 * @see org.eclipse.sirius.sample.bmod.Door
	 * @generated
	 */
	EClass getDoor();

	/**
	 * Returns the meta object for the reference list '{@link org.eclipse.sirius.sample.bmod.Door#getTarget <em>Target</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Target</em>'.
	 * @see org.eclipse.sirius.sample.bmod.Door#getTarget()
	 * @see #getDoor()
	 * @generated
	 */
	EReference getDoor_Target();

	/**
	 * Returns the meta object for class '{@link org.eclipse.sirius.sample.bmod.Fire <em>Fire</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Fire</em>'.
	 * @see org.eclipse.sirius.sample.bmod.Fire
	 * @generated
	 */
	EClass getFire();

	/**
	 * Returns the meta object for class '{@link org.eclipse.sirius.sample.bmod.EmergencySign <em>Emergency Sign</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Emergency Sign</em>'.
	 * @see org.eclipse.sirius.sample.bmod.EmergencySign
	 * @generated
	 */
	EClass getEmergencySign();

	/**
	 * Returns the meta object for the reference '{@link org.eclipse.sirius.sample.bmod.EmergencySign#getSorce <em>Sorce</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Sorce</em>'.
	 * @see org.eclipse.sirius.sample.bmod.EmergencySign#getSorce()
	 * @see #getEmergencySign()
	 * @generated
	 */
	EReference getEmergencySign_Sorce();

	/**
	 * Returns the meta object for the reference list '{@link org.eclipse.sirius.sample.bmod.EmergencySign#getTarget <em>Target</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Target</em>'.
	 * @see org.eclipse.sirius.sample.bmod.EmergencySign#getTarget()
	 * @see #getEmergencySign()
	 * @generated
	 */
	EReference getEmergencySign_Target();

	/**
	 * Returns the meta object for class '{@link org.eclipse.sirius.sample.bmod.Outside <em>Outside</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Outside</em>'.
	 * @see org.eclipse.sirius.sample.bmod.Outside
	 * @generated
	 */
	EClass getOutside();

	/**
	 * Returns the meta object for class '{@link org.eclipse.sirius.sample.bmod.Target <em>Target</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Target</em>'.
	 * @see org.eclipse.sirius.sample.bmod.Target
	 * @generated
	 */
	EClass getTarget();

	/**
	 * Returns the meta object for the reference '{@link org.eclipse.sirius.sample.bmod.Target#getDoor <em>Door</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Door</em>'.
	 * @see org.eclipse.sirius.sample.bmod.Target#getDoor()
	 * @see #getTarget()
	 * @generated
	 */
	EReference getTarget_Door();

	/**
	 * Returns the meta object for enum '{@link org.eclipse.sirius.sample.bmod.perceptions <em>perceptions</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>perceptions</em>'.
	 * @see org.eclipse.sirius.sample.bmod.perceptions
	 * @generated
	 */
	EEnum getperceptions();

	/**
	 * Returns the meta object for enum '{@link org.eclipse.sirius.sample.bmod.actions <em>actions</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>actions</em>'.
	 * @see org.eclipse.sirius.sample.bmod.actions
	 * @generated
	 */
	EEnum getactions();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	BmodFactory getBmodFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each operation of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link org.eclipse.sirius.sample.bmod.impl.FloorImpl <em>Floor</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.sirius.sample.bmod.impl.FloorImpl
		 * @see org.eclipse.sirius.sample.bmod.impl.BmodPackageImpl#getFloor()
		 * @generated
		 */
		EClass FLOOR = eINSTANCE.getFloor();

		/**
		 * The meta object literal for the '<em><b>Room</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference FLOOR__ROOM = eINSTANCE.getFloor_Room();

		/**
		 * The meta object literal for the '<em><b>Door</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference FLOOR__DOOR = eINSTANCE.getFloor_Door();

		/**
		 * The meta object literal for the '<em><b>Outside</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference FLOOR__OUTSIDE = eINSTANCE.getFloor_Outside();

		/**
		 * The meta object literal for the '{@link org.eclipse.sirius.sample.bmod.impl.RoomImpl <em>Room</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.sirius.sample.bmod.impl.RoomImpl
		 * @see org.eclipse.sirius.sample.bmod.impl.BmodPackageImpl#getRoom()
		 * @generated
		 */
		EClass ROOM = eINSTANCE.getRoom();

		/**
		 * The meta object literal for the '<em><b>Cell</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ROOM__CELL = eINSTANCE.getRoom_Cell();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ROOM__NAME = eINSTANCE.getRoom_Name();

		/**
		 * The meta object literal for the '<em><b>Condition</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ROOM__CONDITION = eINSTANCE.getRoom_Condition();

		/**
		 * The meta object literal for the '<em><b>Emergencysign</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ROOM__EMERGENCYSIGN = eINSTANCE.getRoom_Emergencysign();

		/**
		 * The meta object literal for the '{@link org.eclipse.sirius.sample.bmod.impl.CellImpl <em>Cell</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.sirius.sample.bmod.impl.CellImpl
		 * @see org.eclipse.sirius.sample.bmod.impl.BmodPackageImpl#getCell()
		 * @generated
		 */
		EClass CELL = eINSTANCE.getCell();

		/**
		 * The meta object literal for the '<em><b>Right</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CELL__RIGHT = eINSTANCE.getCell_Right();

		/**
		 * The meta object literal for the '<em><b>Left</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CELL__LEFT = eINSTANCE.getCell_Left();

		/**
		 * The meta object literal for the '<em><b>Top</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CELL__TOP = eINSTANCE.getCell_Top();

		/**
		 * The meta object literal for the '<em><b>Bottom</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CELL__BOTTOM = eINSTANCE.getCell_Bottom();

		/**
		 * The meta object literal for the '<em><b>Content</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CELL__CONTENT = eINSTANCE.getCell_Content();

		/**
		 * The meta object literal for the '{@link org.eclipse.sirius.sample.bmod.impl.ContentImpl <em>Content</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.sirius.sample.bmod.impl.ContentImpl
		 * @see org.eclipse.sirius.sample.bmod.impl.BmodPackageImpl#getContent()
		 * @generated
		 */
		EClass CONTENT = eINSTANCE.getContent();

		/**
		 * The meta object literal for the '{@link org.eclipse.sirius.sample.bmod.impl.OccupantImpl <em>Occupant</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.sirius.sample.bmod.impl.OccupantImpl
		 * @see org.eclipse.sirius.sample.bmod.impl.BmodPackageImpl#getOccupant()
		 * @generated
		 */
		EClass OCCUPANT = eINSTANCE.getOccupant();

		/**
		 * The meta object literal for the '<em><b>Is Alarmed</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute OCCUPANT__IS_ALARMED = eINSTANCE.getOccupant_IsAlarmed();

		/**
		 * The meta object literal for the '<em><b>Perception</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute OCCUPANT__PERCEPTION = eINSTANCE.getOccupant_Perception();

		/**
		 * The meta object literal for the '<em><b>Action</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute OCCUPANT__ACTION = eINSTANCE.getOccupant_Action();

		/**
		 * The meta object literal for the '{@link org.eclipse.sirius.sample.bmod.impl.DoorImpl <em>Door</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.sirius.sample.bmod.impl.DoorImpl
		 * @see org.eclipse.sirius.sample.bmod.impl.BmodPackageImpl#getDoor()
		 * @generated
		 */
		EClass DOOR = eINSTANCE.getDoor();

		/**
		 * The meta object literal for the '<em><b>Target</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DOOR__TARGET = eINSTANCE.getDoor_Target();

		/**
		 * The meta object literal for the '{@link org.eclipse.sirius.sample.bmod.impl.FireImpl <em>Fire</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.sirius.sample.bmod.impl.FireImpl
		 * @see org.eclipse.sirius.sample.bmod.impl.BmodPackageImpl#getFire()
		 * @generated
		 */
		EClass FIRE = eINSTANCE.getFire();

		/**
		 * The meta object literal for the '{@link org.eclipse.sirius.sample.bmod.impl.EmergencySignImpl <em>Emergency Sign</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.sirius.sample.bmod.impl.EmergencySignImpl
		 * @see org.eclipse.sirius.sample.bmod.impl.BmodPackageImpl#getEmergencySign()
		 * @generated
		 */
		EClass EMERGENCY_SIGN = eINSTANCE.getEmergencySign();

		/**
		 * The meta object literal for the '<em><b>Sorce</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference EMERGENCY_SIGN__SORCE = eINSTANCE.getEmergencySign_Sorce();

		/**
		 * The meta object literal for the '<em><b>Target</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference EMERGENCY_SIGN__TARGET = eINSTANCE.getEmergencySign_Target();

		/**
		 * The meta object literal for the '{@link org.eclipse.sirius.sample.bmod.impl.OutsideImpl <em>Outside</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.sirius.sample.bmod.impl.OutsideImpl
		 * @see org.eclipse.sirius.sample.bmod.impl.BmodPackageImpl#getOutside()
		 * @generated
		 */
		EClass OUTSIDE = eINSTANCE.getOutside();

		/**
		 * The meta object literal for the '{@link org.eclipse.sirius.sample.bmod.impl.TargetImpl <em>Target</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.sirius.sample.bmod.impl.TargetImpl
		 * @see org.eclipse.sirius.sample.bmod.impl.BmodPackageImpl#getTarget()
		 * @generated
		 */
		EClass TARGET = eINSTANCE.getTarget();

		/**
		 * The meta object literal for the '<em><b>Door</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference TARGET__DOOR = eINSTANCE.getTarget_Door();

		/**
		 * The meta object literal for the '{@link org.eclipse.sirius.sample.bmod.perceptions <em>perceptions</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.sirius.sample.bmod.perceptions
		 * @see org.eclipse.sirius.sample.bmod.impl.BmodPackageImpl#getperceptions()
		 * @generated
		 */
		EEnum PERCEPTIONS = eINSTANCE.getperceptions();

		/**
		 * The meta object literal for the '{@link org.eclipse.sirius.sample.bmod.actions <em>actions</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.sirius.sample.bmod.actions
		 * @see org.eclipse.sirius.sample.bmod.impl.BmodPackageImpl#getactions()
		 * @generated
		 */
		EEnum ACTIONS = eINSTANCE.getactions();

	}

} //BmodPackage
