/**
 */
package org.eclipse.sirius.sample.bmod;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>actions</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see org.eclipse.sirius.sample.bmod.BmodPackage#getactions()
 * @model
 * @generated
 */
public enum actions implements Enumerator {
	/**
	 * The '<em><b>Newcomer</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #NEWCOMER_VALUE
	 * @generated
	 * @ordered
	 */
	NEWCOMER(0, "newcomer", "newcomer"),

	/**
	 * The '<em><b>Experienced</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #EXPERIENCED_VALUE
	 * @generated
	 * @ordered
	 */
	EXPERIENCED(1, "experienced", "experienced"),

	/**
	 * The '<em><b>Influencer</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #INFLUENCER_VALUE
	 * @generated
	 * @ordered
	 */
	INFLUENCER(2, "influencer", "influencer");

	/**
	 * The '<em><b>Newcomer</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #NEWCOMER
	 * @model name="newcomer"
	 * @generated
	 * @ordered
	 */
	public static final int NEWCOMER_VALUE = 0;

	/**
	 * The '<em><b>Experienced</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #EXPERIENCED
	 * @model name="experienced"
	 * @generated
	 * @ordered
	 */
	public static final int EXPERIENCED_VALUE = 1;

	/**
	 * The '<em><b>Influencer</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #INFLUENCER
	 * @model name="influencer"
	 * @generated
	 * @ordered
	 */
	public static final int INFLUENCER_VALUE = 2;

	/**
	 * An array of all the '<em><b>actions</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final actions[] VALUES_ARRAY = new actions[] { NEWCOMER, EXPERIENCED, INFLUENCER, };

	/**
	 * A public read-only list of all the '<em><b>actions</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List<actions> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>actions</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param literal the literal.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static actions get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			actions result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>actions</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param name the name.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static actions getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			actions result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>actions</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the integer value.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static actions get(int value) {
		switch (value) {
		case NEWCOMER_VALUE:
			return NEWCOMER;
		case EXPERIENCED_VALUE:
			return EXPERIENCED;
		case INFLUENCER_VALUE:
			return INFLUENCER;
		}
		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final int value;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String name;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String literal;

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private actions(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getValue() {
		return value;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getLiteral() {
		return literal;
	}

	/**
	 * Returns the literal value of the enumerator, which is its string representation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		return literal;
	}

} //actions
